// D3DEvDlg.cpp : implementation file
//

#include "stdafx.h"
#include "D3DEval.h"
#include "D3DEvDlg.h"
#include "direct.h"
#include "testwnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD3DEvalDlg dialog

CD3DEvalDlg::CD3DEvalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD3DEvalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD3DEvalDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CD3DEvalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD3DEvalDlg)
	DDX_Control(pDX, IDC_MODES, m_cbModes);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD3DEvalDlg, CDialog)
	//{{AFX_MSG_MAP(CD3DEvalDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_MODE1, OnMode1)
	ON_BN_CLICKED(IDC_MODE2, OnMode2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD3DEvalDlg message handlers

BOOL CD3DEvalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetInitialState();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CD3DEvalDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CD3DEvalDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CD3DEvalDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

///////////////////////////////////////////////////////////////////////////////
// Code added after AppWizard

// Initialization
void CD3DEvalDlg::SetInitialState()
{
	// Set the default state of the various radio button sets
	CheckRadioButton(IDC_MODE1, IDC_MODE2, IDC_MODE1); // Window
	CheckRadioButton(IDC_TEST1, IDC_TEST2, IDC_TEST1); 
	CheckRadioButton(IDC_LIGHT1, IDC_LIGHT2, IDC_LIGHT1); // mono 

	// Create a DirectDraw object to play with
	m_pDD = new CDirectDraw;
	BOOL b = m_pDD->Create();
	ASSERT(b);

	// Fill the list box with the full-screen display modes
	ShowModes();
}

void CD3DEvalDlg::ShowModes()
{
	m_cbModes.ResetContent();
	char buf[128];
	if (IsDlgButtonChecked(IDC_MODE2)) {

		// Full screen
		int iModes = m_pDD->GetNumModes();
 		DDSURFACEDESC dds;
		for (int i = 0; i < iModes; i++) {
			m_pDD->GetModeInfo(i, &dds);
			sprintf(buf,
					"%4lu x %4lu x %2lu",
					dds.dwWidth,
					dds.dwHeight,
					dds.ddpfPixelFormat.dwRGBBitCount);
			m_cbModes.AddString(buf);
		}

	} else {

		// Windowed
		CDC* pdc = GetDC();
		int iBpp = pdc->GetDeviceCaps(BITSPIXEL);
		ReleaseDC(pdc);
		int iWidth = ::GetSystemMetrics(SM_CXSCREEN);
		sprintf(buf, " 320 x  240 x %d", iBpp);
		m_cbModes.AddString(buf);
		if (iWidth >= 640) {
			sprintf(buf, " 640 x  480 x %2d", iBpp);
			m_cbModes.AddString(buf);
			if (iWidth >= 800) {
				sprintf(buf, " 800 x  600 x %2d", iBpp);
				m_cbModes.AddString(buf);
				if (iWidth >= 1024) {
					sprintf(buf, "1024 x 768 x %2d", iBpp);
					m_cbModes.AddString(buf);
				}
			}
		}
	}

	m_cbModes.SetCurSel(0);
}

void CD3DEvalDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	delete m_pDD;
}

void CD3DEvalDlg::OnMode1() 
{
	ShowModes();
}

void CD3DEvalDlg::OnMode2() 
{
	ShowModes();
}

// Start the experiment Egor.
// Yes master
void CD3DEvalDlg::OnOK() 
{
	
	TESTINFO* pti = new TESTINFO;
	memset(pti, 0, sizeof(TESTINFO));
	
	// Get the selections
	pti->bFullScreen = FALSE;
	if (IsDlgButtonChecked(IDC_MODE2)) {
		pti->bFullScreen = TRUE;
	}
	pti->iTest = 1;
	if (IsDlgButtonChecked(IDC_TEST2)) {
		pti->iTest = 2;
	}
	pti->iLightMode = 1;
	if (IsDlgButtonChecked(IDC_LIGHT2)) {
		pti->iLightMode = 2;
	}

	// Get the mode setting
	char buf[128];
	m_cbModes.GetWindowText(buf, sizeof(buf));
	sscanf(buf, "%d x %d x %d", &pti->iWidth, &pti->iHeight, &pti->iBpp);

	// Create the test window and execute the tests
	pti->pParent = this;
	CTestWnd* pTW = new CTestWnd;
	pTW->Create(pti);
}
