// testwnd.h

// test info structure
typedef struct _TESTINFO {
	// Input data
	BOOL bFullScreen;
	int iTest;
	int iWidth;
	int iHeight;
	int iBpp;
	int iLightMode;
	CWnd* pParent;

	// Results
	HRESULT hr;
	double dFrameRate;
} TESTINFO;

/////////////////////////////////////////////////////////////////////////////
// CTestWnd window

class CTestWnd : public CWnd
{
public:
	CTestWnd();
	BOOL Create(TESTINFO* pti);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestWnd)
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTestWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTestWnd)
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void Test1();
	void Test2MONO();
	void Test2RGB();
		
	TESTINFO* m_pTI;
	CDirectDraw* m_pDD;
	CDirect3D* m_pD3D;
	IDirect3D* m_pIEngine;
	IDirect3DDevice* m_pIDevice;
	IDirect3DViewport* m_pIViewport;
	CLight m_Light1;
	CMatrix m_mWorld;
	CMatrix m_mProjection;
	CMatrix m_mView;
	CMaterial m_matBkgnd;
};

/////////////////////////////////////////////////////////////////////////////
